 #!/usr/bin/env python

# Calculate points on a circle

from math import *


"""
G18 F25
X0.5000 Z-0.5000
G2 X0.0000 Z0.0000 I-0.5000 K-0.0000
If I or K is == 0 then radius is == fabs(I+K)
Radius is calculated by I = Side_b and K = Side_a and radius = side_c

Starting at Xstart Zstart move in by Xstep then move to Zend
    then move out by Xstep then rapid to Zstart
    them move to Xstep * 2 and save current position as Xstep
    Angle A = degrees(asin(a/c)
    Angle B = degrees(asin(b/c)
"""

"""
r = .25 radius of the arc
t = .092 X distance from segment to center
k = 0.125 Z distance from start point to center of circle
c = 2*sqrt((r*r)-(t*t))
z = (c/2)-k Z point from start point.
z
0.10745644753372618
"""
Xstart = 0.3594
Zstart = 1.0007
Xstep = 0.025
feed = 10



gcode_read = 'G3 X0.1719 Z-0.8132 I0.0000 K0.1875'
line = gcode_read.split()
if line[0] == 'G3':
  # extract the X Z I K
  X = float(line[1][1:])
  Z = float(line[2][1:])
  I = float(line[3][1:])
  K = float(line[4][1:])
  # find the radius of the arc
  if I == 0 or K == 0:
    radius = fabs(I+K)
  if I != 0 and K != 0:
    radius = sqrt((I*I)+(K*K))

  #print 'G0 X{0:.4f} Z{1:.4f}'.format(Xstart, Zstart)
  #print 'G0 X{0:.4f}'.format(Xstart - Xstep)
  #print 'G1 Z{0:.4f} F{1:.1f}'.format(zend, feed)
  #print 'G3 X{0:.4f} Z{1:.4f} I{2:.4f} K{3:.4f}'.format(Xlast, Zlast, I+Xstep, -cl/2)
  #print 'G1 X{0:.4f}'.format(Xlast+Xstep)
  #print 'G0 Z{0:.4f}'.format(Zstart)

  cd = fabs(I) # chord distance from center of the arc
  Xlast = 0.2165
  z_arc_start = -0.3750
  Zlast = -0.3750
  Xcurrent = Xstart
  gcode = []
  gcode.append('G8 G18') # preamble
  gcode.append('F{0:.1f}'.format(feed))
  gcode.append('G0 X{0:.4f} Z{1:.4f}'.format(Xstart, Zstart)) # rapid to start

  while (X < Xcurrent):
    Xcurrent = Xcurrent - Xstep
    if Xcurrent > X:
      cd = cd - Xstep
    else:
      Xcurrent = X
      cd = 0.0
    gcode.append('G1 X{0:.4f}'.format(Xcurrent)) # move to X
    cl = 2 * sqrt((radius*radius)-(cd * cd)) # chord length
    zend = ((cl / 2) - fabs(K)) + z_arc_start # Z end position
    gcode.append('G1 Z{0:.4f}'.format(zend))
    gcode.append('G3 X{0:.4f} Z{1:.4f} I{2:.4f} K{3:.4f}'.format(Xlast, Zlast, -cd, -cl/2))
    gcode.append('G1 X{0:.4f}'.format(Xlast + Xstep))
    gcode.append('G0 Z{0:.4f}'.format(Zstart))
    Zlast = zend
    Xlast = Xcurrent
  gcode.append('M2')
  print '\n'.join(gcode)
if line[0] == 'G1':
  print 'G1 move'
