#!/usr/bin/env python

# Rough to a line for a lathe.
from math import *

gcode = []
gcode.append('G0 X0.3594 Z0.1')
gcode.append('G1 X0.3594 Z-1.000')
gcode.append('G1 X0.1719 Z-0.8132')
line = gcode[0]
print line.split()
print line

Xstart = 0.3594 # X start point
Zstart = 0.1 # Z start point
Xstep = 0.010 # depth of cut
Offset = 0.010 # roughing offset
Feed = 10
Xa = Xstart # X start of the angle same as Xstart
Za = -1.0 # Z start of the angle
Xb = 0.1719 # X end of angle
Zb = -0.8132 # Z end of angle
Xc = Xa # base of triangle
Zc = Zb # base of triangle

# adjacent side
side_a = sqrt((Za - Zc)*(Za - Zc))
#print side_a

# opposite side
side_b = sqrt((Xb - Xc)*(Xb - Xc))
#print side_b

# hypotenuse side
side_c = sqrt(((side_a)*(side_a)) + ((side_b)*(side_b)))
#print side_c

# find angle B formed by sides a and c
angle_B = degrees(asin(side_a/side_c))
#print angle_B

# find the length of side a per X step
Zstep = Xstep * tan(radians(angle_B))
#
#print Zstep

Xcurrent = Xstart - Xstep
Xpasses = int(side_b / Xstep)
Xlast = Xa
Zlast = Za

#print 'G8 G18 G20 G40 G49 G64 P0.005 G80 G90 G92.1 G94'
#print 'F{0:.1f}'.format(Feed)
#print 'G0 X{0:.4f} Z{1:.4f}'.format(Xstart, Zstart)
#print "G1 X{0:.4f}".format(Xcurrent)

for i in range(Xpasses):
  Xnow = Xlast - Xstep
  Znow = Zlast + Zstep
  #print 'G1 Z{0:.4f}'.format(Znow)
  #print 'G1 X{0:.4f} Z{1:.4f}'.format(Xlast, Zlast)
  #print 'G1 X{0:.4f}'.format(Xlast + Xstep)
  #print 'G0 Z{0:.4f}'.format(Zstart)
  if i != range(Xpasses)[-1]:
    #print 'G0 X{0:.4f}'.format(Xnow - Xstep)
    pass
  Xlast -= Xstep
  Zlast += Zstep 
#print 'M2'
